#include <stdio.h>   /* required for file io definitions */
#include <malloc.h>
/* #include <stdlib.h> */
#include <math.h>

#define PI     3.1415926
#define K8     8192
#define NGMAX     K8
#define NXV       K8
#define NVY       NXV/2
#define NSPM      8  
#define HISTMAX           512
#define NVBINMAX        128
#define MAXPARTICLES    16001

#ifndef DBL_MIN
#define DBL_MIN   1E-200
#endif

#ifndef True
#define True            1
#endif

#ifndef False
#define False           0
#endif

/***********************************/
						  
#if defined(GLOBALORIGIN)
#define GLOBAL
#else
#define GLOBAL extern
#endif

GLOBAL float l, dx, dt, la, ael, epsi, rho0, a1, a2, e0, w0, ese_hist, p,
				 ecconst;

GLOBAL float *kes_hist, *pxs_hist, *esem_hist, *ms, *qs, *ts, *nms;

GLOBAL float far *ese, far **kes, far **pxs, far **esem, far *ke, far *te, far *x, far *vx, far *vy,
				 far *x_array,  far *t_array, far *k_array, far *rho, far *phi, far *phik, far *e,
				 far *acc, far *dvbin, far *v_array, far *vbint, far *vbin, far *vbinstart,
				 far *vbin_inst;

GLOBAL double t;

GLOBAL FILE *InputDeck;

GLOBAL int it, nt, ith, ithl, hist_hi, interval, nsp, localnsp, accum,
		 mmax, ng, ng1, iw, ec, k_hi, ins[NSPM+2], np[NSPM+2],vbins[NSPM +2],nvbin[NSPM];


GLOBAL float frand();
#undef GLOBAL

/***********************************************
/* function prototypes */

void accel(int ilp, int iup, float q, float m, float t, float far *p, float far *ke) ;
void init(int *il1, int *il2, float *m, float *q, float *t, float *nm, int *vbin1,
	int *vbin2, float far *dvb, float far *vstart, int *nvbin);
void setv(int il, int iu, float q, float m, float t, float far *p, float far *ke);
void cpft(float far *r, float far *i, int n, int incp, float signp);
void rpft2(float far *a, float far *b, int n, int incp);
void rpfti2(float far *a, float far *b, int n, int incp);

