#include "es1.h"
#include "\win\wingraph.h"
/****************************************************************/

InitWindows(int argc, char** argv)
{
	int i, num=0, nfv=0;
	char buffer[80];
	char **buffer1;
	char **buffer2;
	char **buffer3;
	XY_DATA prevptr, ptr;

	for(i=1; i<=nsp; i++)   if(ts[i]) num++;
	
	localnsp= (nsp>1) ? nsp: 0;
	if (accum) nfv = localnsp + 2;
	
	MAXWINDOWS= 8 + mmax + localnsp + num + nfv;

	MINWINWIDTH= 100;
	MINWINHEIGHT= 60;

	TimePtr= "t";

	/*********************************************/
	/* The following lines should not be changed */
		
	InitMenuBar();
	InitTools();
	InitFileTool();
			
	window= (WindowType)calloc(MAXWINDOWS, sizeof(struct window_struct));
	priorityq= (int *)calloc(MAXWINDOWS, sizeof(int));
		
	HighestP= -1;

	/********************************************************/
	/* The first letter of label for y_axes must be unique  */ 
	
	buffer1= (char **)malloc(localnsp*sizeof(char *));
	buffer2= (char **)malloc(num*sizeof(char *));
	buffer3= (char **)malloc(mmax*sizeof(char *));
	
	for(i=0; i<localnsp; i++)
		buffer1[i]= (char *)malloc(40*sizeof(char));
	
	for(i=0; i<num; i++)
		buffer2[i]= (char *)malloc(40*sizeof(char));
	
	for(i=0; i<mmax; i++)
		buffer3[i]= (char *)malloc(40*sizeof(char));

	/********************************/
	/* The Y labels for the windows */
	
	window[0].Y_Label= "VX Phase Space";
	window[1].Y_Label= "E field";
	window[2].Y_Label= "Potential(x)";
	window[3].Y_Label= "Potential(k)";
	window[4].Y_Label= "Density";
	window[5].Y_Label= "Kinetic Energy";

	for(i=0; i< localnsp; i++){
		sprintf(buffer1[i], "Kinetic %d", i+1);
		window[6+i].Y_Label= buffer1[i];
	}
	
	window[6+localnsp].Y_Label= "Total Energy";
	window[7+localnsp].Y_Label= "Field Energy";

	for(i=0; i< mmax; i++){
		sprintf(buffer3[i], "Mode %d ESE", i+1);
		window[8+localnsp+i].Y_Label= buffer3[i];
	}
	
	for(i=0; i< nsp; i++)
	{
		if(ts[i+1])
		{
			sprintf(buffer2[i], "Vy-Vx Phase Space %d", i+1);
			window[8+localnsp+mmax+i].Y_Label= buffer2[i];
		}
	}

	for (i=0; i<nfv-2; i++)
	{
		sprintf(buffer, "Species %d f(Vx)", i+1);
		window[8 + localnsp + mmax + num + i].Y_Label = strdup(buffer);
	}

	if (accum)
	{
		window[8 + localnsp + mmax + num + nfv - 2].Y_Label = "f(v) all species";
		window[8 + localnsp + mmax + num + nfv - 1].Y_Label = "f(v) total";
	}

	/********************************/
	/* The X labels for the windows */
	
	for(i=0; i<3; i++)
		window[i].X_Label= "X";

	window[3].X_Label= "k";
	window[4].X_Label= "X";

	for(i=5; i< 8+localnsp+mmax; i++)
		window[i].X_Label= "Time";

	for(i=0; i< nsp; i++)
		if(ts[i+1])     window[8+localnsp+mmax+i].X_Label= "Vx";

	for (i=0; i<nfv; i++)
		window[8 + localnsp + mmax + num + i].X_Label = "velocity";

	/*********************/
	
	window[0].state=0;
	window[0].ymax = 3.0;
	window[0].ymin =-3.0;
	window[0].xmax = l;
	window[0].xmin = 0.0;
	window[0].xscale= dx;
	window[0].yscale= dx/dt;
	YNotAutoRescale(window[0]);
	XNotAutoRescale(window[0]);

	for(i=1; i < 8+localnsp+mmax; i++)
	{
		window[i].state=0;
		window[i].xscale=1.0;
		window[i].yscale=1.0;
		YAutoRescale(window[i]);
		XAutoRescale(window[i]);
	}
	for (i=1; i < 7+localnsp; i++) SetLinear(window[i]);
   for (i=7+localnsp; i < 8+localnsp+mmax; i++) SetSemilog(window[i]);
	
	for(i=0; i< nsp; i++)
	{
		if(ts[i+1])
		{
			window[8+localnsp+mmax+i].state=0;
			window[8+localnsp+mmax+i].ymax= 3.0;
			window[8+localnsp+mmax+i].ymin=-3.0;
			window[8+localnsp+mmax+i].xmax= 3.0;
			window[8+localnsp+mmax+i].xmin=-3.0;
			window[8+localnsp+mmax+i].xscale= dx/dt;
			window[8+localnsp+mmax+i].yscale= dx/dt;
			YNotAutoRescale(window[8+localnsp+mmax+i]);
			XNotAutoRescale(window[8+localnsp+mmax+i]);
		}
	}

	for (i=0; i<nfv; i++)
	{
		int index = 8 + localnsp + mmax + num + i;
		window[index].state = 0;
		window[index].xscale = 1;
		window[index].yscale = 1;
		YAutoRescale(window[index]);
		XAutoRescale(window[index]);
		SetLinear(window[index]);
		SetWindowPosition(index, THIRDQUAD);
	}

	/*******************/                                    

	SetWindowPosition(0, UPPERHALF);

	for(i=1; i< 5; i++)
		SetWindowPosition(i, THIRDQUAD);

	for(i=5; i< 8+localnsp+mmax; i++)
		SetWindowPosition(i, FOURTHQUAD);

	for(i=0; i<nsp; i++)
		if(ts[i+1])     SetWindowPosition(8+localnsp+mmax+i, LOWERHALF);

	/****************************************/
	/* Assigning x and y arrays to windows */
	
	prevptr= ptr= NULL;

	for (i=nsp; i>= 1; i--)
	{
		ptr= SetupDataStruct();
		ptr->y= &vx[ins[i]];
		ptr->x= &x[ins[i]];
		ptr->npoint= &np[i];
		ptr->color = COLOR[i-1];
		ptr->next= prevptr;
		prevptr= ptr;
	}
	window[0].data= ptr;                    /* Phase Space */

	ptr= SetupDataStruct();
	ptr->y= &e[1];
	ptr->x= x_array;
	ptr->npoint= &ng1;
	ptr->color = COLOR[2];
	window[1].data= ptr;                    /* E Field */

	ptr= SetupDataStruct();
	ptr->y= &phi[1];
	ptr->x= x_array;
	ptr->npoint= &ng1;
	ptr->color = COLOR[2];
	window[2].data= ptr;                    /* Potential(x) */

	ptr= SetupDataStruct();
	ptr->y= &phik[1];
	ptr->x= k_array;
	ptr->npoint= &k_hi;
	ptr->color = COLOR[4];
	window[3].data= ptr;                    /* Potential(k) */

	ptr= SetupDataStruct();
	ptr->y= &rho[1];
	ptr->x= x_array;
	ptr->npoint= &ng1;
	ptr->color = COLOR[2];
	window[4].data= ptr;                    /* Total Charge Density */

	ptr= SetupDataStruct();
	ptr->y= ke;
	ptr->x= t_array;
	ptr->npoint= &hist_hi;
	ptr->color = COLOR[4];
	window[5].data= ptr;                    /* Total Kinetic Energy */

	for(i=6; i<6+localnsp; i++)
	{
		ptr= SetupDataStruct();
		ptr->y= kes[i-6];
		ptr->x= t_array;
		ptr->npoint= &hist_hi;
		ptr->color = COLOR[i-6];
		window[i].data= ptr;            /* Kinetic Energy of ith Species */
	}

	ptr= SetupDataStruct();
	ptr->y= te;
	ptr->x= t_array;
	ptr->npoint= &hist_hi;
	ptr->color = COLOR[4];
	window[6+localnsp].data= ptr;                   /* Total Energy */

	ptr= SetupDataStruct();
	ptr->y= ese;
	ptr->x= t_array;
	ptr->npoint= &hist_hi;
	ptr->color = COLOR[4];
	window[7+localnsp].data= ptr;                   /* Total Field Energy */

	for(i=8+localnsp; i<8+localnsp+mmax; i++)
	{
		ptr= SetupDataStruct();
		ptr->y= esem[i-8-localnsp];
		ptr->x= t_array;
		ptr->npoint= &hist_hi;
		ptr->color = COLOR[4];                                                          
		window[i].data= ptr;                    /* Mode ith */
	}

	for(i=1; i<= nsp; i++)
	{
		if(ts[i])
		{
			ptr= SetupDataStruct();
			ptr->y= &vy[ins[i]];
			ptr->x= &vx[ins[i]];
			ptr->npoint= &np[i];
			ptr->color = COLOR[i-1];
			window[8+localnsp+mmax+i-1].data= ptr;  /* Velocity Space of ith Speceis */
		}
	}

	for (i=0; i<nfv - 2; i++) /* f(v) for each species */
	{
		ptr = SetupDataStruct();
		ptr->x = &v_array[vbins[i+1]];
		ptr->y = &vbin[vbins[i+1]];
		ptr->npoint = &nvbin[i+1];
		ptr->color = COLOR[i];
		window[8 + localnsp + mmax + num + i].data = ptr;
	}

	/* f(v) for all species */
	if (accum)
	{
		prevptr = ptr = NULL;
		for (i=0; i<nsp; i++)
		{
			ptr = SetupDataStruct();
			ptr->x = &v_array[vbins[i+1]];
			ptr->y = &vbin[vbins[i+1]];
			ptr->npoint = &nvbin[i+1];
			ptr->color = COLOR[i];
			ptr->next = prevptr;
			prevptr = ptr;
		}
		window[8 + localnsp + mmax + num + nfv - 2].data = ptr;

		ptr = SetupDataStruct();
		ptr->x = &v_array[vbins[1]];
		ptr->y = vbint;
		ptr->npoint = &nvbin[1];
		ptr->color = COLOR[3];
		window[8 + localnsp + mmax + num + nfv - 1].data = ptr;
	}

	/************************************************************/
	/* This function must be called at the end of the routine   */
	
	InitDiagnostics();
}

/****************************************************************/
void Dump()
{

}
