#include "es1.h"

#define Zero_Order   1
#define First_Order  2
#define Energy_Conserving 3

move(ilp,iup,q)
int ilp,iup;
float q;
{
   int il,iu;
	register int i, j;
   float xn,qdx,drho;

	il = ilp;
	iu = iup;
	qdx = q/dx;
	xn = ng;
	switch (iw) 
	{
		case Zero_Order :
			for (i=il;i <= iu;i++) 
			{
				x[i] += vx[i];
				if (x[i] < 0.0) x[i] += xn;
				else if (x[i] >= xn) x[i] -= xn;
				j = x[i] + 0.5;
				rho[j+1] += qdx;
			}
			break;
		case First_Order :
		case Energy_Conserving :
			for (i=il;i <= iu;i++) 
			{
				x[i] += vx[i];
				if (x[i] < 0.0) x[i] += xn;
				else if (x[i] >= xn) x[i] -= xn;
				j = x[i];
				drho = qdx*(x[i] - j);
				rho[j+1] += qdx - drho;
				rho[j+2] += drho;
			}
			break;
		default:
			printf("Bad iw switch in move \n");
			exit(-1);
			break;
	}
}
