#include "es1.h"

#define Zero_Order   1
#define First_Order  2
#define Energy_Conserving 3

setrho(il,iu,q,rhos)
int il,iu;
float q,rhos;
{
   register int i,j;
   float qdx,drho;
   static float dxi,xn;

	qdx = q/dx;
	if ( il == 1 ) {
		for (j=1;j <= ng;j++) rho[j] = rho0;
		rho[ng1] = 0.0;
		dxi = 1.0/dx;
		xn = ng;
	}
	rho0 -= rhos;
	for (j=1;j <= ng;j++) rho[j] -= rhos;
	switch (iw) {
		case Zero_Order :
			for (i=il;i <= iu;i++) {
				x[i] *= dxi;
				if (x[i] < 0.0) x[i] += xn;
				if (x[i] >= xn) x[i] -= xn;
				j = x[i] + 0.5;
				rho[j + 1] += qdx;
			}
			break;
		case First_Order :
		case Energy_Conserving :
			for (i=il;i <= iu;i++) {
				x[i] *= dxi;
				if (x[i] < 0.0) x[i] += xn;
				if (x[i] >= xn) x[i] -= xn;
				j = x[i];
				drho = qdx*(x[i] - j);
				rho[j + 1] += qdx - drho;
				rho[j + 2] += drho;
			}
			break;
		default:
			printf(" Bad iw switch in setrho. \n");
			exit(-1);
			break;
	}
}

/****************************************************************/

extern double sqrt();

setv(il, iu, q, m, t, p, ke)
int il, iu;
float q, m, t, *p, *ke;
{
	register int i;
	float dtdx, c, s, vxx;
	
	dtdx = dt/dx;
	if (t != 0.0)
	{
		c = 1.0 /sqrt(1.0 + t*t);
		s = c*t;
		for (i=il; i<=iu; i++)
		{
			vxx = vx[i];
			vx[i] =  c*vxx + s*vy[i];
			vy[i] = -s*vxx + c*vy[i];
			vy[i] *= dtdx;
		}
	}
	for (i=il; i<=iu; i++) vx[i] *= dtdx;
	accel(il, iu, -0.5*q, m, 0.0, p, ke);
}
